"use strict";
class HttpException extends Error {
    constructor(message) {
        super(message);
        this.message = message;
        this.statusCode = 500;
        // this.name = 'HttpException';
        // this.message = message;
        // this.stack = (<any>new Error()).stack;
    }
    getStatusCode() {
        return this.statusCode;
    }
    getData() {
        return this.data;
    }
}
exports.HttpException = HttpException;
// Exception list:
// 400 BadRequest
// 401 Unauthorized
// 402 PaymentRequired
// 403 Forbidden
// 404 NotFound
// 405 MethodNotAllowed
// 406 NotAcceptable
// 407 ProxyAuthenticationRequired
// 408 RequestTimeout
// 409 Conflict
// 410 Gone
// 411 LengthRequired
// 412 PreconditionFailed
// 413 PayloadTooLarge
// 414 URITooLong
// 415 UnsupportedMediaType
// 416 RangeNotSatisfiable
// 417 ExpectationFailed
// 422 UnprocessableEntity
// 429 TooManyRequests
// 451 UnavailableForLegalReasons
// 500 InternalServerError
// 501 NotImplemented
// 503 ServiceUnavailable
// 507 InsufficientStorage
/**
 * Defines Error class for Bad Request errors, with HTTP status code 400
 */
class BadRequestException extends HttpException {
    constructor(message = 'Bad Request') {
        super(message);
        this.statusCode = 400;
        this.name = 'BadRequestException';
    }
}
exports.BadRequestException = BadRequestException;
/**
 * Defines Error class for Unauthorized errors, with HTTP status code 401
 */
class UnauthorizedException extends HttpException {
    constructor(message = 'Unauthorized') {
        super(message);
        this.statusCode = 401;
        this.name = 'UnauthorizedException';
    }
}
exports.UnauthorizedException = UnauthorizedException;
/**
 * Defines Error class for Payment Required errors, with HTTP status code 402
 */
class PaymentRequiredException extends HttpException {
    constructor(message = 'Payment Required') {
        super(message);
        this.statusCode = 402;
        this.name = 'PaymentRequiredException';
    }
}
exports.PaymentRequiredException = PaymentRequiredException;
/**
 * Defines Error class for Forbidden errors, with HTTP status code 403
 */
class ForbiddenException extends HttpException {
    constructor(message = 'Forbidden') {
        super(message);
        this.statusCode = 403;
        this.name = 'ForbiddenException';
    }
}
exports.ForbiddenException = ForbiddenException;
/**
 * Defines Error class for Not Found errors, with HTTP status code 404
 */
class NotFoundException extends HttpException {
    constructor(message = 'Not Found') {
        super(message);
        this.statusCode = 404;
        this.name = 'NotFoundException';
    }
}
exports.NotFoundException = NotFoundException;
/**
 * Defines Error class for Method Not Allowed errors, with HTTP status code 405
 */
class MethodNotAllowedException extends HttpException {
    constructor(message = 'Method Not Allowed') {
        super(message);
        this.statusCode = 405;
        this.name = 'MethodNotAllowedException';
    }
}
exports.MethodNotAllowedException = MethodNotAllowedException;
/**
 * Defines Error class for Not Acceptable errors, with HTTP status code 406
 */
class NotAcceptableException extends HttpException {
    constructor(message = 'Not Acceptable') {
        super(message);
        this.statusCode = 406;
        this.name = 'NotAcceptableException';
    }
}
exports.NotAcceptableException = NotAcceptableException;
/**
 * Defines Error class for Proxy Authentication Required errors, with HTTP status code 407
 */
class ProxyAuthenticationRequiredException extends HttpException {
    constructor(message = 'Proxy Authentication Required') {
        super(message);
        this.statusCode = 407;
        this.name = 'ProxyAuthenticationRequiredException';
    }
}
exports.ProxyAuthenticationRequiredException = ProxyAuthenticationRequiredException;
/**
 * Defines Error class for Request Timeout errors, with HTTP status code 408
 */
class RequestTimeoutException extends HttpException {
    constructor(message = 'Request Timeout') {
        super(message);
        this.statusCode = 408;
        this.name = 'RequestTimeoutException';
    }
}
exports.RequestTimeoutException = RequestTimeoutException;
/**
 * Defines Error class for Conflict errors, with HTTP status code 409
 */
class ConflictException extends HttpException {
    constructor(message = 'Conflict') {
        super(message);
        this.statusCode = 409;
        this.name = 'ConflictException';
    }
}
exports.ConflictException = ConflictException;
/**
 * Defines Error class for Gone errors, with HTTP status code 410
 */
class GoneException extends HttpException {
    constructor(message = 'Gone') {
        super(message);
        this.statusCode = 410;
        this.name = 'GoneException';
    }
}
exports.GoneException = GoneException;
/**
 * Defines Error class for Length Required errors, with HTTP status code 411
 */
class LengthRequiredException extends HttpException {
    constructor(message = 'Length Required') {
        super(message);
        this.statusCode = 411;
        this.name = 'LengthRequiredException';
    }
}
exports.LengthRequiredException = LengthRequiredException;
/**
 * Defines Error class for Precondition Failed errors, with HTTP status code 412
 */
class PreconditionFailedException extends HttpException {
    constructor(message = 'Precondition Failed') {
        super(message);
        this.statusCode = 412;
        this.name = 'PreconditionFailedException';
    }
}
exports.PreconditionFailedException = PreconditionFailedException;
/**
 * Defines Error class for Payload Too Large errors, with HTTP status code 413
 */
class PayloadTooLargeException extends HttpException {
    constructor(message = 'Payload Too Large') {
        super(message);
        this.statusCode = 413;
        this.name = 'PayloadTooLargeException';
    }
}
exports.PayloadTooLargeException = PayloadTooLargeException;
/**
 * Defines Error class for URI Too Long errors, with HTTP status code 414
 */
class URITooLongException extends HttpException {
    constructor(message = 'URI Too Long') {
        super(message);
        this.statusCode = 414;
        this.name = 'URITooLongException';
    }
}
exports.URITooLongException = URITooLongException;
/**
 * Defines Error class for Unsupported Media Type errors, with HTTP status code 415
 */
class UnsupportedMediaTypeException extends HttpException {
    constructor(message = 'Unsupported Media Type') {
        super(message);
        this.statusCode = 415;
        this.name = 'UnsupportedMediaTypeException';
    }
}
exports.UnsupportedMediaTypeException = UnsupportedMediaTypeException;
/**
 * Defines Error class for Range Not Satisfiable errors, with HTTP status code 416
 */
class RangeNotSatisfiableException extends HttpException {
    constructor(message = 'Range Not Satisfiable') {
        super(message);
        this.statusCode = 416;
        this.name = 'RangeNotSatisfiableException';
    }
}
exports.RangeNotSatisfiableException = RangeNotSatisfiableException;
/**
 * Defines Error class for Expectation Failed errors, with HTTP status code 417
 */
class ExpectationFailedException extends HttpException {
    constructor(message = 'Expectation Failed') {
        super(message);
        this.statusCode = 417;
        this.name = 'ExpectationFailedException';
    }
}
exports.ExpectationFailedException = ExpectationFailedException;
/**
 * Defines Error class for Unprocessable Entity errors, with HTTP status code 422
 */
class UnprocessableEntityException extends HttpException {
    constructor(message = 'Unprocessable Entity') {
        super(message);
        this.statusCode = 422;
        this.name = 'UnprocessableEntityException';
    }
}
exports.UnprocessableEntityException = UnprocessableEntityException;
/**
 * Defines Error class for Too Many Requests errors, with HTTP status code 429
 */
class TooManyRequestsException extends HttpException {
    constructor(message = 'Too Many Requests') {
        super(message);
        this.statusCode = 429;
        this.name = 'TooManyRequestsException';
    }
}
exports.TooManyRequestsException = TooManyRequestsException;
/**
 * Defines Error class for Unavailable For Legal Reasons errors, with HTTP status code 451
 */
class UnavailableForLegalReasonsException extends HttpException {
    constructor(message = 'Unavailable For Legal Reasons') {
        super(message);
        this.statusCode = 451;
        this.name = 'UnavailableForLegalReasonsException';
    }
}
exports.UnavailableForLegalReasonsException = UnavailableForLegalReasonsException;
/**
 * Defines Error class for Internal Server Error errors, with HTTP status code 500
 */
class InternalServerErrorException extends HttpException {
    constructor(message = 'Internal Server Error') {
        super(message);
        this.statusCode = 500;
        this.name = 'InternalServerErrorException';
    }
}
exports.InternalServerErrorException = InternalServerErrorException;
/**
 * Defines Error class for Not Implemented errors, with HTTP status code 501
 */
class NotImplementedException extends HttpException {
    constructor(message = 'Not Implemented') {
        super(message);
        this.statusCode = 501;
        this.name = 'NotImplementedException';
    }
}
exports.NotImplementedException = NotImplementedException;
/**
 * Defines Error class for Service Unavailable errors, with HTTP status code 503
 */
class ServiceUnavailableException extends HttpException {
    constructor(message = 'Service Unavailable') {
        super(message);
        this.statusCode = 503;
        this.name = 'ServiceUnavailableException';
    }
}
exports.ServiceUnavailableException = ServiceUnavailableException;
/**
 * Defines Error class for Insufficient Storage errors, with HTTP status code 503
 */
class InsufficientStorageException extends HttpException {
    constructor(message = 'Insufficient Storage') {
        super(message);
        this.statusCode = 507;
        this.name = 'InsufficientStorageException';
    }
}
exports.InsufficientStorageException = InsufficientStorageException;
/**
 * Defines Error class for Validation exceptions
 */
class ValidationException extends UnprocessableEntityException {
    constructor(message = 'Validation error', errors) {
        super(message);
        this.name = 'UnprocessableEntityException';
        this.data = errors;
    }
}
exports.ValidationException = ValidationException;
//# sourceMappingURL=exceptions.js.map