"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
const model_1 = require('./model');
const collection_1 = require('./collection');
const primary_decorator_1 = require('./types/primary.decorator');
class BasicModel extends model_1.AbstractModel {
}
__decorate([
    primary_decorator_1.Primary(), 
    __metadata('design:type', Number)
], BasicModel.prototype, "id", void 0);
describe('Collection', () => {
    let collection;
    let data;
    beforeEach(() => {
        data = [
            new BasicModel({ id: 1 }),
            new BasicModel({ id: 2 }),
        ];
        collection = new collection_1.Collection(data);
    });
    it('can iterate over the collection with forEach', () => {
        collection.forEach((item, index) => {
            expect(item)
                .toEqual(data[index]);
        });
    });
    it('can iterate with for...of', () => {
        let count = 0;
        for (let item of collection) {
            count++;
            expect(item instanceof BasicModel)
                .toBe(true);
        }
        expect(count)
            .toEqual(collection.length);
    });
    it('can find an item', () => {
        expect(collection.findById(2))
            .toEqual(collection[1]);
    });
    it('throws error when item can\'t be found', () => {
        let errorFind = () => collection.findById(3);
        expect(errorFind)
            .toThrowError(`Item with id [3] not in collection`);
    });
    it('can check if an entity is present in the collection', () => {
        expect(collection.contains(data[1]))
            .toBe(true);
        expect(collection.contains(new BasicModel({ id: 10 })))
            .toBe(false);
    });
});
//# sourceMappingURL=collection.spec.js.map