"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
const model_1 = require('./model');
const primary_decorator_1 = require('./types/primary.decorator');
class BasicModel extends model_1.AbstractModel {
    constructor() {
        super(...arguments);
        this.stringWithDefault = 'foo';
    }
}
__decorate([
    primary_decorator_1.Primary(), 
    __metadata('design:type', String)
], BasicModel.prototype, "id", void 0);
describe('Model', () => {
    let instance;
    const id = 'f0d8368d-85e2-54fb-73c4-2d60374295e3';
    beforeEach(() => {
        instance = new BasicModel({ id });
    });
    it('hydrates a basic model', () => {
        expect(instance.id)
            .toEqual(id);
    });
    it('retrieves the identifier with @Primary decorator', () => {
        expect(instance.getIdentifier())
            .toEqual(id);
    });
    it('retains default property values', () => {
        expect(instance.stringWithDefault)
            .toEqual('foo');
    });
    it('returns undefined for properties without default', () => {
        expect(instance.stringNoDefault)
            .toEqual(undefined);
    });
    it('creates a model without properties if none are passed', () => {
        const model = new BasicModel;
        expect(Object.assign({}, model)).toEqual({ stringWithDefault: 'foo' });
    });
});
describe('UUID', () => {
    it('extends String', () => {
        const id = new model_1.UUID('72eed629-c4ab-4520-a987-4ea26b134d8c');
        expect(id instanceof model_1.UUID).toBe(true);
        expect(id instanceof String).toBe(true);
    });
});
//# sourceMappingURL=model.spec.js.map