"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
const metadata_1 = require('../../metadata/metadata');
class Relation {
    constructor(model, foreignRelationModelGetter, viaProperty, databaseOptions) {
        this.model = model;
        this.foreignRelationModelGetter = foreignRelationModelGetter;
        this.viaProperty = viaProperty;
        this.databaseOptions = databaseOptions;
    }
    get foreign() {
        return this.foreignRelationModelGetter(this.model);
    }
}
exports.Relation = Relation;
/**
 * Initializes relation metadata property with empty values. Common function used by all relation
 * decorators to verify there is somewhere to assign their metadata.
 * @param target
 * @param type
 */
function initializeRelationMap(target, type) {
    metadata_1.initializeMetadata(target.constructor);
    if (!target.constructor.__metadata.relations) {
        target.constructor.__metadata.relations = new Map();
    }
    if (!target.constructor.__metadata.relations.has(type)) {
        target.constructor.__metadata.relations.set(type, new Map());
    }
}
exports.initializeRelationMap = initializeRelationMap;
__export(require('./hasOne.decorator'));
__export(require('./belongsTo.decorator'));
//# sourceMappingURL=index.js.map