"use strict";
const thumb_model_fixture_1 = require('./thumb.model.fixture');
const hand_model_fixture_1 = require('./hand.model.fixture');
describe('Model Relations', () => {
    it('registers hasOne relationship with the constructor', () => {
        const model = new hand_model_fixture_1.HandModel();
        const relations = model.getMetadata().relations;
        expect(relations)
            .toBeDefined();
        expect(relations.get('hasOne')
            .get('thumb').foreign)
            .toEqual(thumb_model_fixture_1.ThumbModel);
    });
    it('registers belongsTo relationship with metadata', () => {
        const model = new thumb_model_fixture_1.ThumbModel();
        const relations = model.getMetadata().relations;
        expect(relations.get('belongsTo')
            .get('hand').foreign)
            .toEqual(hand_model_fixture_1.HandModel);
        expect(relations.get('belongsTo')
            .get('hand').viaProperty(new hand_model_fixture_1.HandModel({ handId: 1 })))
            .toEqual(1);
    });
});
//# sourceMappingURL=relations.spec.js.map