"use strict";
const storedProperty_decorator_1 = require('./storedProperty.decorator');
/**
 *  @Primary property decorator for assigning which property is the primary identifier
 * @returns {function(ModelConstructor<any>, string): void}
 * @constructor
 */
function Primary(options) {
    return function primary(target, propertyKey) {
        //associate with store properties so it doesn't need to be called twice
        storedProperty_decorator_1.StoredProperty(options)(target, propertyKey);
        target.constructor.__metadata.identifierKey = propertyKey;
    };
}
exports.Primary = Primary;
//# sourceMappingURL=primary.decorator.js.map