"use strict";
const metadata_1 = require('../../metadata/metadata');
/**
 *  @StoredProperty property decorator for assigning the field type of the decorated property
 * @returns {function(ModelConstructor<any>, string): void}
 * @constructor
 */
function StoredProperty(options) {
    return function storedProperty(target, propertyKey) {
        metadata_1.initializeMetadata(target.constructor);
        if (!target.constructor.__metadata.storedProperties) {
            target.constructor.__metadata.storedProperties = new Map();
        }
        let type = Reflect.getMetadata("design:type", target, propertyKey);
        target.constructor.__metadata.storedProperties.set(propertyKey, { type, columnOptions: options });
    };
}
exports.StoredProperty = StoredProperty;
//# sourceMappingURL=storedProperty.decorator.js.map