"use strict";
const metadata_1 = require('../../metadata/metadata');
/**
 * Initializes the timestamps metadata property with empty values
 * @param target
 */
function initTimestamps(target) {
    metadata_1.initializeMetadata(target.constructor);
    if (!target.constructor.__metadata.timestamps) {
        target.constructor.__metadata.timestamps = {};
    }
}
/**
 *  @CreatedDate property decorator for assigning which property is to be defined as the created date
 * @returns {function(ModelConstructor<any>, string): void}
 * @constructor
 */
function CreatedDate() {
    return function createdDate(target, propertyKey) {
        initTimestamps(target);
        target.constructor.__metadata.timestamps.created = propertyKey;
    };
}
exports.CreatedDate = CreatedDate;
/**
 *  @UpdatedDate property decorator for assigning which property is to be defined as the updated date
 * @returns {function(ModelConstructor<any>, string): void}
 * @constructor
 */
function UpdatedDate() {
    return function updatedDate(target, propertyKey) {
        initTimestamps(target);
        target.constructor.__metadata.timestamps.updated = propertyKey;
    };
}
exports.UpdatedDate = UpdatedDate;
//# sourceMappingURL=timestamp.decorator.js.map