/**
 * @module common
 */
/** End Typedoc Module Declaration */
import { Logger, LogLevel } from './logger.service';
export declare const isBrowser: () => boolean;
/**
 * A concrete implementation of [[Logger]] this is a generic logger that will log to the console.
 * It can be used in both frontend and backend, and will log to the respective consoles.
 * Only in the NodeJS environment does colour highlighting take place
 */
export declare class ConsoleLogger extends Logger {
    private envBrowser;
    constructor();
    /**
     * Format the log with an appropriate colour
     * @param logLevel
     * @param message
     * @returns {string}
     */
    format(logLevel: LogLevel, message: string): string;
    /**
     * Format the messages - in node env anything that is not a string is passed into util.inspect
     * for coloured syntax highlighting
     * @param logLevel
     * @param messages
     * @returns {any}
     */
    private formatMessages(logLevel, messages);
    /**
     * Output the log to console. The log messages are prepended with the current time and source if
     * set
     * @param logLevel
     * @param messages
     * @returns {ConsoleLogger}
     */
    persistLog(logLevel: LogLevel, messages: any[]): this;
}
