/**
 * @module common
 */
/**
 * Common interface that all services *must* extend
 */
export declare abstract class AbstractService {
    /**
     * Method called at startup to defer bootstrapping of other components until resolved
     * @returns {Promise<AbstractService>}
     */
    initialize(): Promise<this> | this;
}
