"use strict";
/**
 * @module common
 */
/**
 * Common interface that all services *must* extend
 */
class AbstractService {
    /**
     * Method called at startup to defer bootstrapping of other components until resolved
     * @returns {Promise<AbstractService>}
     */
    initialize() {
        return Promise.resolve(this);
    }
}
exports.AbstractService = AbstractService;
//# sourceMappingURL=service.js.map