/**
 * @module common
 */
/** End Typedoc Module Declaration */
"use strict";
const chalk = require('chalk');
/**
 * Zeroth Banner for usage in cli welcome
 * @type {string}
 */
exports.banner = `
                0
           00    00000
        0000      00  0000
    00000        0000    00000
 0000           000000       0000
000              0   000       000
000     00            000      000
000  000000             00     000
000   000     Zeroth     000   000
000     00             000000  000
000      000            00     000
000       000   0              000
 0000       000000           0000
    00000    000         00000
        0000  000     0000
            00000    00
                 0`;
function bannerBg(message = '$ Zeroth Runtime CLI', bgString) {
    let shortMessage = '';
    let longMessage = '';
    message = ` ${message} `;
    message.length > 36 ? longMessage = message : shortMessage = message;
    shortMessage += "*".repeat(38 - shortMessage.length);
    const template = `
**************************************   **************************************
*********************************      0      *********************************
******************************    00    00000     *****************************
**************************     0000      00  0000     *************************
***********************    00000        0000    00000    **********************
*********************** 0000           000000       0000  *********************
********************** 000              0   000       000 *********************
********************** 000     00            000      000 *********************
********************** 000  000000             00     000 *********************
********************** 000   000     Zeroth     000   000 *********************
********************** 000     00             000000  000 *********************
********************** 000      000            00     000 *********************
********************** 000       000   0              000 *********************
*********************** 0000       000000           0000 **********************
***********************    00000    000         00000    **********************
**************************     0000  000     0000     *************************
******************************     00000    00    *****************************
**********************************      0      ********************************
***************************************   *************************************
*******************************************************************************
${longMessage}`;
    const minReplacementLength = template.match(/\*+/g)
        .join('').length;
    if (bgString.length < minReplacementLength) {
        bgString = bgString.repeat(minReplacementLength / bgString.length + 1);
    }
    return template
        .replace(/0/g, '\u2b21')
        .replace(/\*+/g, (match) => {
        const replacement = bgString.substr(0, match.length);
        bgString = bgString.substr(match.length);
        return chalk.gray(replacement);
    });
}
exports.bannerBg = bannerBg;
//# sourceMappingURL=banner.js.map