/**
 * @module common
 */
/** End Typedoc Module Declaration */
export interface PromiseFactory<T> {
    (arg?: any, ...args: any[]): T | Promise<T>;
}
/**
 * Invoke a series of promise factories one after the other, only kicking off the next promise
 * when the prior one resolves.
 * @param promiseFactories
 * @returns {Promise<any>}
 * @param thisArg
 * @param args
 * @param initialValue
 */
export declare function serialPromise<T>(promiseFactories: PromiseFactory<T>[], initialValue: T, thisArg?: any, ...args: any[]): Promise<T>;
