"use strict";
/**
 * Invoke a series of promise factories one after the other, only kicking off the next promise
 * when the prior one resolves.
 * @param promiseFactories
 * @returns {Promise<any>}
 * @param thisArg
 * @param args
 * @param initialValue
 */
function serialPromise(promiseFactories, initialValue, thisArg = null, ...args) {
    return promiseFactories.reduce((soFar, next) => {
        return soFar.then((result) => {
            return Promise.resolve(next.call(thisArg, result, ...args));
        });
    }, Promise.resolve(initialValue));
}
exports.serialPromise = serialPromise;
//# sourceMappingURL=serialPromise.js.map