"use strict";
const serialPromise_1 = require('./serialPromise');
describe('Process promises sequentially', () => {
    it('should be able to run a series of promises in sequence', () => {
        let promiseFactories = [
                (value) => Promise.resolve(value + 1),
                (value) => Promise.resolve(value + 2),
                (value) => Promise.resolve(value + 3),
        ];
        let promiseResult = serialPromise_1.serialPromise(promiseFactories, 0);
        promiseResult.then((result) => {
            expect(result)
                .toEqual(6);
        });
    });
    it('should be able to run a series of promises in sequence with extra arguments', () => {
        let promiseFactories = [
                (value, extra) => Promise.resolve(value + 1 + extra),
                (value, extra) => Promise.resolve(value + 2 + extra),
                (value, extra) => Promise.resolve(value + 3 + extra),
        ];
        let promiseResult = serialPromise_1.serialPromise(promiseFactories, 0, null, 2);
        return promiseResult.then((result) => {
            expect(result)
                .toEqual(12);
        });
    });
});
//# sourceMappingURL=serialPromise.spec.js.map