"use strict";
/**
 * @module server
 */
/** End Typedoc Module Declaration */
const entity_bootstrapper_1 = require('./entity.bootstrapper');
const abstract_server_1 = require('../servers/abstract.server');
/**
 * Provides bootstrapping of the @[[Controller]] entities
 */
class ControllerBootstrapper extends entity_bootstrapper_1.EntityBootstrapper {
    /**
     * Returns all controllers registered to the [[EntityRegistry]]
     */
    getInjectableEntities() {
        return this.getEntitiesFromRegistry('controller');
    }
    bootstrap() {
        const server = this.injector.get(abstract_server_1.Server);
        this.entities.forEach((resolvedController) => {
            let controller = this.getInstance(resolvedController);
            controller.registerInjector(this.injector)
                .registerRoutes(server);
        });
    }
}
exports.ControllerBootstrapper = ControllerBootstrapper;
//# sourceMappingURL=controllers.bootstrapper.js.map