/**
 * @module server
 */
/** End Typedoc Module Declaration */
import { EntityBootstrapper } from './entity.bootstrapper';
import { RegistryEntityStatic, EntityMetadata } from '../../common/registry/entityRegistry';
/**
 * Provides bootstrapping of the @[[Migration]] entities
 */
export declare class MigrationBootstrapper extends EntityBootstrapper {
    /**
     * Returns all migrations registered to the [[EntityRegistry]]
     */
    getInjectableEntities(): RegistryEntityStatic<EntityMetadata>[];
    /**
     * Runs all migrations, awaiting completion of all before the main bootstrapper proceed
     * @todo update to assign tasks to the remote cli so it doesn't happen on startup
     * @returns {Promise<any>|Promise<void[]>}
     */
    bootstrap(): Promise<void>;
}
