/**
 * @module server
 */
/** End Typedoc Module Declaration */
import { EntityBootstrapper } from './entity.bootstrapper';
/**
 * Provides bootstrapping of the @[[Model]] entities
 */
export declare class ModelBootstrapper extends EntityBootstrapper {
    /**
     * Models are not injectable, so this method simply returns an empty array
     * @returns {Array}
     */
    getInjectableEntities(): any[];
    /**
     * Bootstraps the models. Each model has it's metadata mapped to the decorators from TypeORM
     * which are invoked to register their metadata with the internal TypeORM. This registry is later
     * used by the ModelStores which manipulate the TypeORM repository
     */
    bootstrap(): void;
}
