"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
const testing_1 = require('@angular/core/testing');
const core_1 = require('@angular/core');
const remoteCli_service_mock_1 = require('../services/remoteCli.service.mock');
const remoteCli_service_1 = require('../services/remoteCli.service');
const abstract_server_mock_1 = require('../servers/abstract.server.mock');
const logger_service_1 = require('../../common/services/logger.service');
const logger_service_mock_1 = require('../../common/services/logger.service.mock');
const abstract_server_1 = require('../servers/abstract.server');
const bootstrap_1 = require('./bootstrap');
const entityRegistry_1 = require('../../common/registry/entityRegistry');
const model_1 = require('../../common/models/model');
const primary_decorator_1 = require('../../common/models/types/primary.decorator');
const storedProperty_decorator_1 = require('../../common/models/types/storedProperty.decorator');
const typeorm = require('typeorm');
const timestamp_decorator_1 = require('../../common/models/types/timestamp.decorator');
const auth_service_mock_1 = require('../services/auth.service.mock');
const auth_service_1 = require('../services/auth.service');
const providers = [
    { provide: logger_service_1.Logger, useClass: logger_service_mock_1.LoggerMock },
    { provide: abstract_server_1.Server, useClass: abstract_server_mock_1.ServerMock },
    { provide: remoteCli_service_1.RemoteCli, useClass: remoteCli_service_mock_1.RemoteCliMock },
    { provide: auth_service_1.AuthService, useClass: auth_service_mock_1.AuthServiceMock },
];
let TestModel = class TestModel extends model_1.AbstractModel {
};
__decorate([
    primary_decorator_1.Primary({ type: 'integer' }), 
    __metadata('design:type', Number)
], TestModel.prototype, "id", void 0);
__decorate([
    storedProperty_decorator_1.StoredProperty({ length: '10' }), 
    __metadata('design:type', String)
], TestModel.prototype, "name", void 0);
__decorate([
    timestamp_decorator_1.CreatedDate(), 
    __metadata('design:type', Date)
], TestModel.prototype, "createdAt", void 0);
__decorate([
    timestamp_decorator_1.UpdatedDate(), 
    __metadata('design:type', Date)
], TestModel.prototype, "updatedAt", void 0);
TestModel = __decorate([
    core_1.Injectable(), 
    __metadata('design:paramtypes', [])
], TestModel);
describe('Model Bootstrapper', () => {
    beforeEach(() => {
        testing_1.TestBed.configureTestingModule({ providers });
        entityRegistry_1.EntityRegistry.clearAll();
        entityRegistry_1.EntityRegistry.register('model', TestModel);
    });
    it('resolves and initializes model with Typeorm decorators', (done) => {
        const result = bootstrap_1.bootstrap(undefined, providers)();
        const decoratorSpy = (lib, decorator) => {
            const invoked = jasmine.createSpy(decorator);
            const registered = spyOn(lib, decorator)
                .and
                .callFake(() => invoked);
            return { invoked, registered };
        };
        const primaryColumnSpy = decoratorSpy(typeorm, 'PrimaryColumn');
        const columnSpy = decoratorSpy(typeorm, 'Column');
        const createDateSpy = decoratorSpy(typeorm, 'CreateDateColumn');
        const updateDateSpy = decoratorSpy(typeorm, 'UpdateDateColumn');
        return result.then((res) => {
            expect(primaryColumnSpy.registered)
                .toHaveBeenCalledWith({ type: 'integer' });
            expect(primaryColumnSpy.invoked)
                .toHaveBeenCalledWith(TestModel.prototype, 'id');
            expect(columnSpy.registered)
                .toHaveBeenCalledWith({ length: '10' });
            expect(columnSpy.invoked)
                .toHaveBeenCalledWith(TestModel.prototype, 'name');
            expect(createDateSpy.registered)
                .toHaveBeenCalled();
            expect(createDateSpy.invoked)
                .toHaveBeenCalledWith(TestModel.prototype, 'createdAt');
            expect(updateDateSpy.registered)
                .toHaveBeenCalled();
            expect(updateDateSpy.invoked)
                .toHaveBeenCalledWith(TestModel.prototype, 'updatedAt');
            done();
        });
    });
});
//# sourceMappingURL=models.bootstrapper.spec.js.map