"use strict";
/**
 * @module server
 */
/** End Typedoc Module Declaration */
const entity_bootstrapper_1 = require('./entity.bootstrapper');
/**
 * Provides bootstrapping of the @[[Seeder]] entities
 */
class SeederBootstrapper extends entity_bootstrapper_1.EntityBootstrapper {
    /**
     * Returns all seeders registered to the [[EntityRegistry]]
     */
    getInjectableEntities() {
        return this.getEntitiesFromRegistry('seeder');
    }
    /**
     * Runs all seeders, awaiting completion of all before the main bootstrapper proceed
     * @todo update to assign tasks to the remote cli so it doesn't happen on startup
     * @returns {Promise<any>|Promise<void[]>}
     */
    bootstrap() {
        const allSeederPromises = this.entities.map((resolvedSeeder) => {
            return this.getInstance(resolvedSeeder).seed();
        }, []);
        return Promise.all(allSeederPromises);
    }
}
exports.SeederBootstrapper = SeederBootstrapper;
//# sourceMappingURL=seeders.bootstrapper.js.map