"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
const testing_1 = require('@angular/core/testing');
const core_1 = require('@angular/core');
const remoteCli_service_mock_1 = require('../services/remoteCli.service.mock');
const remoteCli_service_1 = require('../services/remoteCli.service');
const abstract_server_mock_1 = require('../servers/abstract.server.mock');
const logger_service_1 = require('../../common/services/logger.service');
const logger_service_mock_1 = require('../../common/services/logger.service.mock');
const abstract_server_1 = require('../servers/abstract.server');
const bootstrap_1 = require('./bootstrap');
const entityRegistry_1 = require('../../common/registry/entityRegistry');
const index_1 = require('../seeders/index');
const auth_service_mock_1 = require('../services/auth.service.mock');
const auth_service_1 = require('../services/auth.service');
let loggerInstance = new logger_service_mock_1.LoggerMock();
const providers = [
    {
        provide: logger_service_1.Logger,
        deps: [],
        useValue: loggerInstance
    },
    { provide: abstract_server_1.Server, useClass: abstract_server_mock_1.ServerMock },
    { provide: remoteCli_service_1.RemoteCli, useClass: remoteCli_service_mock_1.RemoteCliMock },
    { provide: auth_service_1.AuthService, useClass: auth_service_mock_1.AuthServiceMock },
];
let TestSeeder = class TestSeeder extends index_1.AbstractSeeder {
    constructor(logger) {
        super(logger);
    }
    seed() {
        this.logger.debug('Test seeder running');
        return Promise.resolve();
    }
};
TestSeeder = __decorate([
    core_1.Injectable(), 
    __metadata('design:paramtypes', [logger_service_1.Logger])
], TestSeeder);
exports.TestSeeder = TestSeeder;
describe('Seeder Bootstrapper', () => {
    beforeEach(() => {
        testing_1.TestBed.configureTestingModule({ providers });
        entityRegistry_1.EntityRegistry.clearAll();
        entityRegistry_1.EntityRegistry.register('seeder', TestSeeder);
    });
    it('resolves and runs seeder', (done) => {
        const loggerSpy = spyOn(loggerInstance, 'persistLog')
            .and
            .callThrough();
        spyOn(loggerInstance, 'source')
            .and
            .callFake(() => loggerInstance);
        const result = bootstrap_1.bootstrap(undefined, providers)();
        return result.then((res) => {
            expect(loggerSpy)
                .toHaveBeenCalledWith('debug', ['Test seeder running']);
            done();
        });
    });
});
//# sourceMappingURL=seeders.bootstrapper.spec.js.map