/**
 * @module server
 */
/** End Typedoc Module Declaration */
import { EntityBootstrapper } from './entity.bootstrapper';
import { RegistryEntityStatic, EntityMetadata } from '../../common/registry/entityRegistry';
/**
 * Provides bootstrapping of the @[[Service]] entities
 */
export declare class ServiceBootstrapper extends EntityBootstrapper {
    /**
     * Returns all services registered to the [[EntityRegistry]]
     */
    getInjectableEntities(): RegistryEntityStatic<EntityMetadata>[];
    /**
     * Bootstrap all services. With each service, the initialize function is invoked, and the bootstrap
     * awaits all services to complete initializing before resolving the promise
     * @returns {Promise<any>|Promise<AbstractService[]>}
     */
    bootstrap(): Promise<void>;
}
