"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
const testing_1 = require('@angular/core/testing');
const core_1 = require('@angular/core');
const logger_service_1 = require('../../common/services/logger.service');
const abstract_server_1 = require('../servers/abstract.server');
const logger_service_mock_1 = require('../../common/services/logger.service.mock');
const abstract_server_mock_1 = require('../servers/abstract.server.mock');
const remoteCli_service_1 = require('../services/remoteCli.service');
const remoteCli_service_mock_1 = require('../services/remoteCli.service.mock');
const request_1 = require('./request');
const response_1 = require('./response');
const abstract_controller_1 = require('./abstract.controller');
const route_decorator_1 = require('./route.decorator');
const exceptions_1 = require('../../common/exceptions/exceptions');
const auth_service_mock_1 = require('../services/auth.service.mock');
const auth_service_1 = require('../services/auth.service');
let TestController = class TestController extends abstract_controller_1.AbstractController {
    constructor(logger) {
        super(logger);
    }
    test(request, response) {
        return response.data('Hello World');
    }
    httpError(request, response) {
        throw new exceptions_1.UnavailableForLegalReasonsException("You can't see that");
    }
    unknownError(request, response) {
        throw new Error('Something went terribly wrong');
    }
};
__decorate([
    route_decorator_1.Route('GET', '/test'), 
    __metadata('design:type', Function), 
    __metadata('design:paramtypes', [request_1.Request, response_1.Response]), 
    __metadata('design:returntype', response_1.Response)
], TestController.prototype, "test", null);
__decorate([
    route_decorator_1.Route('GET', '/http-error'), 
    __metadata('design:type', Function), 
    __metadata('design:paramtypes', [request_1.Request, response_1.Response]), 
    __metadata('design:returntype', response_1.Response)
], TestController.prototype, "httpError", null);
__decorate([
    route_decorator_1.Route('GET', '/unknown-error'), 
    __metadata('design:type', Function), 
    __metadata('design:paramtypes', [request_1.Request, response_1.Response]), 
    __metadata('design:returntype', response_1.Response)
], TestController.prototype, "unknownError", null);
TestController = __decorate([
    core_1.Injectable(), 
    __metadata('design:paramtypes', [logger_service_1.Logger])
], TestController);
const providers = [
    TestController,
    { provide: logger_service_1.Logger, useClass: logger_service_mock_1.LoggerMock },
    { provide: abstract_server_1.Server, useClass: abstract_server_mock_1.ServerMock },
    { provide: remoteCli_service_1.RemoteCli, useClass: remoteCli_service_mock_1.RemoteCliMock },
    { provide: auth_service_1.AuthService, useClass: auth_service_mock_1.AuthServiceMock },
];
describe('Controller', () => {
    beforeEach(() => {
        testing_1.TestBed.configureTestingModule({ providers });
    });
    it('Registers a route that returns a response', testing_1.async(testing_1.inject([TestController, abstract_server_1.Server], (c, s) => {
        c.registerRoutes(s);
        const callStackHandler = s.configuredRoutes.find((r) => r.methodName == 'test').callStackHandler;
        let request = new request_1.Request();
        let response = new response_1.Response();
        return callStackHandler(request, response)
            .then((finalResponse) => {
            expect(finalResponse.body)
                .toEqual('Hello World');
        });
    })));
    it('Registers a route that returns an http error response', testing_1.async(testing_1.inject([TestController, abstract_server_1.Server], (c, s) => {
        c.registerRoutes(s);
        const callStackHandler = s.configuredRoutes.find((r) => r.methodName == 'httpError').callStackHandler;
        let request = new request_1.Request();
        let response = new response_1.Response();
        return callStackHandler(request, response)
            .then((finalResponse) => {
            expect(finalResponse.statusCode)
                .toEqual(451);
            expect(finalResponse.body)
                .toEqual({ message: "UnavailableForLegalReasonsException: You can't see that" });
        });
    })));
    it('Registers a route that falls back to an http error respnse', testing_1.async(testing_1.inject([TestController, abstract_server_1.Server], (c, s) => {
        c.registerRoutes(s);
        const callStackHandler = s.configuredRoutes.find((r) => r.methodName == 'unknownError').callStackHandler;
        let request = new request_1.Request();
        let response = new response_1.Response();
        return callStackHandler(request, response)
            .then((finalResponse) => {
            expect(finalResponse.statusCode)
                .toEqual(500);
            expect(finalResponse.body)
                .toEqual({ message: 'InternalServerErrorException: Something went terribly wrong' });
        });
    })));
});
//# sourceMappingURL=abstract.controller.spec.js.map