"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
const testing_1 = require('@angular/core/testing');
const core_1 = require('@angular/core');
const resource_controller_1 = require('./resource.controller');
const logger_service_1 = require('../../common/services/logger.service');
const abstract_server_1 = require('../servers/abstract.server');
const logger_service_mock_1 = require('../../common/services/logger.service.mock');
const model_1 = require('../../common/models/model');
const abstract_server_mock_1 = require('../servers/abstract.server.mock');
const mock_store_1 = require('../../common/stores/mock.store');
const store_1 = require('../../common/stores/store');
const remoteCli_service_1 = require('../services/remoteCli.service');
const remoteCli_service_mock_1 = require('../services/remoteCli.service.mock');
const request_1 = require('./request');
const response_1 = require('./response');
const collection_1 = require('../../common/models/collection');
const events_1 = require('events');
const primary_decorator_1 = require('../../common/models/types/primary.decorator');
const _ = require('lodash');
const auth_service_mock_1 = require('../services/auth.service.mock');
const auth_service_1 = require('../services/auth.service');
class Fruit extends model_1.AbstractModel {
}
__decorate([
    primary_decorator_1.Primary(), 
    __metadata('design:type', Number)
], Fruit.prototype, "fruitId", void 0);
class FruitStore extends store_1.AbstractStore {
}
class FruitMockStore extends mock_store_1.MockStore {
    constructor() {
        super(Fruit, null);
    }
    getMock(id) {
        return new this.modelStatic({
            fruitId: id || this.chance()
                .integer(),
            name: 'Banana',
        });
    }
}
let TestController = class TestController extends resource_controller_1.ResourceController {
    constructor(logger, fruitStore) {
        super(logger, fruitStore);
    }
};
TestController = __decorate([
    core_1.Injectable(), 
    __metadata('design:paramtypes', [logger_service_1.Logger, FruitStore])
], TestController);
const providers = [
    TestController,
    { provide: FruitStore, useClass: FruitMockStore },
    { provide: logger_service_1.Logger, useClass: logger_service_mock_1.LoggerMock },
    { provide: abstract_server_1.Server, useClass: abstract_server_mock_1.ServerMock },
    { provide: remoteCli_service_1.RemoteCli, useClass: remoteCli_service_mock_1.RemoteCliMock },
    { provide: auth_service_1.AuthService, useClass: auth_service_mock_1.AuthServiceMock },
];
describe('Resource Controller', () => {
    beforeEach(() => {
        testing_1.TestBed.configureTestingModule({ providers });
    });
    it('Registers a route to retrieve an entity', testing_1.async(testing_1.inject([TestController, abstract_server_1.Server], (c, s) => {
        c.registerRoutes(s);
        const callStackHandler = s.configuredRoutes.find((r) => r.methodName == 'getOne').callStackHandler;
        const params = new Map();
        params.set('id', 123);
        let request = new request_1.Request(null, params);
        let response = new response_1.Response();
        return callStackHandler(request, response)
            .then((finalResponse) => {
            expect(finalResponse.body instanceof Fruit)
                .toBe(true);
            expect(finalResponse.body.getIdentifier())
                .toBe(123);
        });
    })));
    it('Registers a route to delete an entity', testing_1.async(testing_1.inject([TestController, abstract_server_1.Server], (c, s) => {
        c.registerRoutes(s);
        const methodInfo = s.configuredRoutes.find((r) => r.methodName == 'deleteOne');
        expect(methodInfo)
            .toBeDefined(`method info should exist for 'deleteOne'`);
        const params = new Map();
        params.set('id', 123);
        let emitter = new events_1.EventEmitter();
        emitter.setEncoding = () => null;
        let request = new request_1.Request(emitter);
        let response = new response_1.Response();
        return c.modelStore.findOne(123)
            .then((fixture) => {
            process.nextTick(() => {
                emitter.emit('data', JSON.stringify(fixture));
                emitter.emit('end');
            });
            return methodInfo.callStackHandler(request, response)
                .then((finalResponse) => {
                expect(finalResponse.body instanceof Fruit)
                    .toBe(true);
                expect(finalResponse.body.getIdentifier())
                    .toBe(123);
            });
        });
    })));
    it('Registers a route to patch an entity', testing_1.async(testing_1.inject([TestController, abstract_server_1.Server], (c, s) => {
        c.registerRoutes(s);
        const methodInfo = s.configuredRoutes.find((r) => r.methodName == 'patchOne');
        expect(methodInfo)
            .toBeDefined(`method info should exist for 'patchOne'`);
        let emitter = new events_1.EventEmitter();
        emitter.setEncoding = () => null;
        let request = new request_1.Request(emitter);
        let response = new response_1.Response();
        return c.modelStore.findOne(123)
            .then((fixture) => {
            process.nextTick(() => {
                emitter.emit('data', JSON.stringify(fixture));
                emitter.emit('end');
            });
            return methodInfo.callStackHandler(request, response)
                .then((finalResponse) => {
                expect(finalResponse.body instanceof Fruit)
                    .toBe(true);
                expect(finalResponse.body.getIdentifier())
                    .toBe(123);
            });
        });
    })));
    it('Throws exception when patch is attempted on entity that does not exist', testing_1.async(testing_1.inject([TestController, abstract_server_1.Server], (c, s) => {
        c.registerRoutes(s);
        const methodInfo = s.configuredRoutes.find((r) => r.methodName == 'patchOne');
        expect(methodInfo)
            .toBeDefined(`method info should exist for 'patchOne'`);
        let emitter = new events_1.EventEmitter();
        emitter.setEncoding = () => null;
        let request = new request_1.Request(emitter);
        let response = new response_1.Response();
        return c.modelStore.findOne(123)
            .then((fixture) => {
            fixture = _.clone(fixture);
            fixture.fruitId = 999; //not in store
            const hasOneSpy = spyOn(c.modelStore, 'hasOne').and.callThrough();
            process.nextTick(() => {
                emitter.emit('data', JSON.stringify(fixture));
                emitter.emit('end');
            });
            return methodInfo.callStackHandler(request, response)
                .then((res) => {
                expect(hasOneSpy).toHaveBeenCalledWith(fixture);
                expect(res.body.message).toEqual('NotFoundException: Model with id [999] does not exist');
            });
        });
    })));
    it('Registers a route to retrieve many entities', testing_1.async(testing_1.inject([TestController, abstract_server_1.Server], (c, s) => {
        c.registerRoutes(s);
        const callStackHandler = s.configuredRoutes.find((r) => r.methodName == 'getMany').callStackHandler;
        let request = new request_1.Request();
        let response = new response_1.Response();
        return callStackHandler(request, response)
            .then((finalResponse) => {
            expect(finalResponse.body instanceof collection_1.Collection)
                .toBe(true);
            expect(finalResponse.body[0] instanceof Fruit)
                .toBe(true);
            expect(finalResponse.body[0].name)
                .toBe('Banana');
        });
    })));
    it('Registers a route put one entity', testing_1.async(testing_1.inject([TestController, abstract_server_1.Server], (c, s) => {
        c.registerRoutes(s);
        const callStackHandler = s.configuredRoutes.find((r) => r.methodName == 'putOne').callStackHandler;
        let emitter = new events_1.EventEmitter();
        emitter.setEncoding = () => null;
        let request = new request_1.Request(emitter);
        let response = new response_1.Response();
        return c.modelStore.findOne(null)
            .then((fixture) => {
            process.nextTick(() => {
                emitter.emit('data', JSON.stringify(fixture));
                emitter.emit('end');
            });
            return callStackHandler(request, response)
                .then((finalResponse) => {
                expect(finalResponse.body instanceof Fruit)
                    .toBe(true);
                expect(finalResponse.body)
                    .toEqual(fixture);
            });
        });
    })));
});
//# sourceMappingURL=resource.controller.spec.js.map