"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
const testing_1 = require('@angular/core/testing');
const request_1 = require('../controllers/request');
const response_1 = require('../controllers/response');
const abstract_controller_1 = require('../controllers/abstract.controller');
const core_1 = require('@angular/core');
const logger_service_1 = require('../../common/services/logger.service');
const abstract_server_1 = require('../servers/abstract.server');
const logger_service_mock_1 = require('../../common/services/logger.service.mock');
const abstract_server_mock_1 = require('../servers/abstract.server.mock');
const remoteCli_service_1 = require('../services/remoteCli.service');
const remoteCli_service_mock_1 = require('../services/remoteCli.service.mock');
const route_decorator_1 = require('./route.decorator');
const auth_service_mock_1 = require('../services/auth.service.mock');
const auth_service_1 = require('../services/auth.service');
const decorators_1 = require('../registry/decorators');
let TestController = class TestController extends abstract_controller_1.AbstractController {
    constructor(logger) {
        super(logger);
    }
    testMethod(request, response) {
    }
};
__decorate([
    route_decorator_1.Route('PUT', '/test/:id'), 
    __metadata('design:type', Function), 
    __metadata('design:paramtypes', [request_1.Request, response_1.Response]), 
    __metadata('design:returntype', Object)
], TestController.prototype, "testMethod", null);
TestController = __decorate([
    core_1.Injectable(),
    decorators_1.Controller({
        routeBase: 'base'
    }), 
    __metadata('design:paramtypes', [logger_service_1.Logger])
], TestController);
const providers = [
    TestController,
    { provide: abstract_server_1.Server, useClass: abstract_server_mock_1.ServerMock },
    { provide: logger_service_1.Logger, useClass: logger_service_mock_1.LoggerMock },
    { provide: remoteCli_service_1.RemoteCli, useClass: remoteCli_service_mock_1.RemoteCliMock },
    { provide: auth_service_1.AuthService, useClass: auth_service_mock_1.AuthServiceMock },
];
describe('@Route decorator', () => {
    beforeEach(() => {
        testing_1.TestBed.configureTestingModule({ providers });
    });
    it('Registers a route definition with the server ', testing_1.inject([TestController, core_1.Injector, abstract_server_1.Server], (c, i, s) => {
        let controller = c.registerInjector(i)
            .registerRoutes(s);
        const routeConfig = s.getRoutes()
            .find((route) => route.methodName == 'testMethod');
        expect(routeConfig.method)
            .toEqual('PUT');
        expect(routeConfig.path)
            .toEqual(process.env.API_BASE + '/base/test/:id');
    }));
});
//# sourceMappingURL=route.decorator.spec.js.map