"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
/**
 * This is the server-only module. It exports classes, functions and interfaces that are for the
 * server implementations to use
 *
 * Any of the types (classes, functions etc) defined under this module can be imported from
 * `@zerothstack/core/server`
 *
 * Example:
 * ```typescript
 * import { AbstractController } from '@zerothstack/core/server';
 * ```
 *
 * @module server
 * @preferred
 */
/** */
__export(require('./main'));
__export(require('./bootstrap'));
__export(require('./controllers'));
__export(require('./servers'));
__export(require('./services'));
__export(require('./seeders'));
__export(require('./migrations'));
__export(require('./stores'));
__export(require('./middleware'));
__export(require('./registry'));
//# sourceMappingURL=index.js.map