"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
const testing_1 = require('@angular/core/testing');
const request_1 = require('../controllers/request');
const response_1 = require('../controllers/response');
const route_decorator_1 = require('../controllers/route.decorator');
const middleware_decorator_1 = require('./middleware.decorator');
const abstract_controller_1 = require('../controllers/abstract.controller');
const core_1 = require('@angular/core');
const logger_service_1 = require('../../common/services/logger.service');
const abstract_server_1 = require('../servers/abstract.server');
const logger_service_mock_1 = require('../../common/services/logger.service.mock');
const abstract_server_mock_1 = require('../servers/abstract.server.mock');
const remoteCli_service_1 = require('../services/remoteCli.service');
const remoteCli_service_mock_1 = require('../services/remoteCli.service.mock');
const debugLog_middleware_1 = require('./debugLog.middleware');
const auth_service_mock_1 = require('../services/auth.service.mock');
const auth_service_1 = require('../services/auth.service');
let MiddlewareController = class MiddlewareController extends abstract_controller_1.AbstractController {
    constructor(logger) {
        super(logger);
    }
    testMethod(request, response) {
        return response;
    }
};
__decorate([
    route_decorator_1.Route('GET', '/test'),
    middleware_decorator_1.Before(debugLog_middleware_1.debugLog('test log input')), 
    __metadata('design:type', Function), 
    __metadata('design:paramtypes', [request_1.Request, response_1.Response]), 
    __metadata('design:returntype', response_1.Response)
], MiddlewareController.prototype, "testMethod", null);
MiddlewareController = __decorate([
    core_1.Injectable(), 
    __metadata('design:paramtypes', [logger_service_1.Logger])
], MiddlewareController);
let source, logs = [];
let mockLogger = {
    source: (input) => {
        source = input;
        return mockLogger;
    },
    debug: (input) => {
        logs.push(input);
    }
};
const providers = [
    MiddlewareController,
    { provide: abstract_server_1.Server, useClass: abstract_server_mock_1.ServerMock },
    { provide: logger_service_1.Logger, useClass: logger_service_mock_1.LoggerMock },
    { provide: remoteCli_service_1.RemoteCli, useClass: remoteCli_service_mock_1.RemoteCliMock },
    { provide: auth_service_1.AuthService, useClass: auth_service_mock_1.AuthServiceMock },
    {
        provide: debugLog_middleware_1.DebugLogMiddleware,
        deps: [],
        useFactory: () => {
            return new debugLog_middleware_1.DebugLogMiddleware(mockLogger);
        },
    }
];
describe('debugLog middleware', () => {
    let controller;
    beforeEach(() => {
        testing_1.TestBed.configureTestingModule({ providers });
    });
    it('Calls debug.log on the passed value to the middleware decorator', testing_1.async(testing_1.inject([MiddlewareController, core_1.Injector, abstract_server_1.Server], (c, i, s) => {
        controller = c.registerInjector(i)
            .registerRoutes(s);
        const callStackHandler = s.getRoutes()
            .find((route) => route.methodName == 'testMethod').callStackHandler;
        let request = new request_1.Request();
        let response = new response_1.Response();
        return callStackHandler(request, response)
            .then(() => {
            expect(source)
                .toEqual('debugLog');
            expect(logs)
                .toEqual(['test log input']);
        });
    })));
});
//# sourceMappingURL=debugLog.middleware.spec.js.map