/**
 * @module server
 */
/** End Typedoc Module Declaration */
import { Logger } from '../../common/services/logger.service';
/**
 * Root class that all implementations of seeders *must* extend. Provides common interface for
 * bootstrapper to handle seeding
 */
export declare abstract class AbstractSeeder {
    protected logger: Logger;
    constructor(loggerBase: Logger);
    /**
     * Start the seeding. Returns promise so bootstrapper can wait until finished before starting
     * the next seeder
     */
    abstract seed(): Promise<void>;
}
