import { Server, RouteConfig } from './abstract.server';
import { RemoteCli } from '../services/remoteCli.service';
import { Logger } from '../../common/services/logger.service';
import { Response } from '../controllers/response';
import { Application, Response as ExpressResponse } from 'express';
export declare class ExpressServer extends Server {
    protected app: Application;
    constructor(logger: Logger, remoteCli: RemoteCli);
    /**
     * @inheritdoc
     * @returns {Application}
     */
    getEngine(): Application;
    /**
     * @inheritdoc
     * @returns {Express}
     */
    protected initialize(): this;
    /**
     * @inheritdoc
     * @returns {any}
     * @param routeConfig
     */
    protected registerRouteWithEngine(routeConfig: RouteConfig): this;
    /**
     * @inheritDoc
     */
    registerStaticLoader(webroot?: string): this;
    /**
     * @inheritdoc
     * @returns {Promise<ExpressServer>}
     */
    startEngine(): Promise<this>;
    /**
     * Send the response
     * @param response
     * @param res
     */
    protected send(response: Response, res: ExpressResponse): void;
    /**
     * Send the error response
     * @param err
     * @param res
     */
    protected sendErr(err: Error, res: ExpressResponse): void;
}
