import { Logger } from '../../common/services/logger.service';
import { Database } from './database.service';
/**
 * Provides no-side effect mock for Database for use in testing fixtures
 */
export declare class DatabaseMock extends Database {
    constructor(loggerBase: Logger);
    /**
     * Mock initialization, doesn't connect to the database. This means calls to
     * `(new DatabaseMock).getConnection()` will return `Promise<void>`
     * @returns {Promise<DatabaseMock>}
     */
    initialize(): Promise<this>;
}
