"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/**
 * @module server
 */
/** End Typedoc Module Declaration */
const core_1 = require('@angular/core');
const logger_service_1 = require('../../common/services/logger.service');
const database_service_1 = require('./database.service');
const decorators_1 = require('../../common/registry/decorators');
/**
 * Provides no-side effect mock for Database for use in testing fixtures
 */
let DatabaseMock = class DatabaseMock extends database_service_1.Database {
    constructor(loggerBase) {
        super(loggerBase);
    }
    /**
     * Mock initialization, doesn't connect to the database. This means calls to
     * `(new DatabaseMock).getConnection()` will return `Promise<void>`
     * @returns {Promise<DatabaseMock>}
     */
    initialize() {
        return Promise.resolve(this);
    }
};
DatabaseMock = __decorate([
    core_1.Injectable(),
    decorators_1.Service(), 
    __metadata('design:paramtypes', [logger_service_1.Logger])
], DatabaseMock);
exports.DatabaseMock = DatabaseMock;
//# sourceMappingURL=database.service.mock.js.map