/**
 * @module server
 */
/** End Typedoc Module Declaration */
import { Injector } from '@angular/core';
import { RemoteCli, ConnectedSocketCallback } from './remoteCli.service';
import { Logger } from '../../common/services/logger.service';
import { AuthService } from './auth.service';
/**
 * Provides no-side effect mock for RemoteCli for use in testing fixtures
 */
export declare class RemoteCliMock extends RemoteCli {
    constructor(loggerBase: Logger, injector: Injector, authService: AuthService);
    /**
     * Override of parent command register method
     * @returns {RemoteCliMock}
     */
    protected registerCommands(): this;
    /**
     * Override of parent start method
     * @param port
     * @param callback
     * @returns {RemoteCliMock}
     */
    start(port: number, callback?: ConnectedSocketCallback): this;
    /**
     * This overrides the parent method so that vantage is not initialised in tests
     * @returns {RemoteCliMock}
     */
    initialize(): this;
}
