"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/**
 * @module server
 */
/** End Typedoc Module Declaration */
const core_1 = require('@angular/core');
const remoteCli_service_1 = require('./remoteCli.service');
const logger_service_1 = require('../../common/services/logger.service');
const decorators_1 = require('../../common/registry/decorators');
const auth_service_1 = require('./auth.service');
/**
 * Provides no-side effect mock for RemoteCli for use in testing fixtures
 */
let RemoteCliMock = class RemoteCliMock extends remoteCli_service_1.RemoteCli {
    constructor(loggerBase, injector, authService) {
        super(loggerBase, injector, authService);
    }
    /**
     * Override of parent command register method
     * @returns {RemoteCliMock}
     */
    registerCommands() {
        return this;
    }
    /**
     * Override of parent start method
     * @param port
     * @param callback
     * @returns {RemoteCliMock}
     */
    start(port, callback) {
        return this;
    }
    /**
     * This overrides the parent method so that vantage is not initialised in tests
     * @returns {RemoteCliMock}
     */
    initialize() {
        return this.registerCommands();
    }
};
RemoteCliMock = __decorate([
    core_1.Injectable(),
    decorators_1.Service(), 
    __metadata('design:paramtypes', [logger_service_1.Logger, core_1.Injector, auth_service_1.AuthService])
], RemoteCliMock);
exports.RemoteCliMock = RemoteCliMock;
//# sourceMappingURL=remoteCli.service.mock.js.map